暴力枚举刷题7-涂国旗

题目来源:涂国旗 - 洛谷
解题思路:

要解决这个问题,我们可以使用暴力枚举方法来找到涂色最少的方案。基本思路是枚举白色区域和蓝色区域的边界行,然后计算将布匹涂成合法国旗所需改变的最少格数。

步骤如下:

  1. 遍历所有可能的白色区域和蓝色区域的边界。假设白色区域的最后一行是 wEnd,蓝色区域的最后一行是 bEnd。则,wEnd 从第1行遍历到第 n-2 行(至少留出一行给蓝色和红色),bEnd 从 wEnd + 1 遍历到第 n-1 行(至少留出一行给红色)。
  2. 对于每一种边界的枚举,计算需要改变的格子数。具体来说,对于白色区域(从第1行到 wEnd 行),计算非白色格子的数量;对于蓝色区域(从 wEnd + 1 行到 bEnd 行),计算非蓝色格子的数量;对于红色区域(从 bEnd + 1 行到最后一行),计算非红色格子的数量。
  3. 在所有可能的边界中找到需要改变格子数最少的方案。
cpp 复制代码
#include<iostream>

using namespace std;

int n, m;
char a[51][51];

int main()
{
	cin >> n >> m;
	for (int i = 0; i < n; i++)
	{
		for (int j = 0; j < m; j++)
		{
			cin >> a[i][j];// 输入旗帜的当前状态
		}
	}
	int ans = 1e9; // 初始化答案为一个很大的数
	//枚举白色区域和蓝色区域的边界
	for (int wEnd = 0; wEnd < n - 2; wEnd++)
	{
		for (int bEnd = wEnd + 1; bEnd < n - 1; bEnd++)
		{
			int count = 0;// 需要改变的格子数
			// 计算需要改变的格子数
			for (int i = 0; i <= wEnd; i++)  白色区域
			{
				for (int j = 0; j < m; j++)
					count += a[i][j] != 'W';
			}
			for (int i = wEnd + 1; i <= bEnd; i++) 蓝色区域
			{
				for (int j = 0; j < m; j++)
				{
					count += a[i][j] != 'B';
				}
			}
			for (int i = bEnd + 1; i <n; i++) 红色区域
			{
				for (int j = 0; j < m; j++)
				{
					count += a[i][j] != 'R';
				}
			}
			ans = min(ans, count);// 更新最少需要改变的格子数
		}
	}

	cout << ans << endl; // 输出结果
	return 0;
}
相关推荐
赛博守夜人15 分钟前
跨境业务与出海合规之九:海外买量投放与营销虚假流量(Ad Fraud):跨国机房群控与归因欺诈识别算法
算法·安全
chenbingjie_c38 分钟前
C++ STL 适配器:stack & queue,从 vector/list 到 deque 深度解析
数据结构·c++
镜子AI3 小时前
教培机构AI推荐系统实战:概念漂移检测算法——为什么“去年有效的推荐今年可能失效“
人工智能·算法
垆边人似月.4 小时前
华为OD算法题:查找众数及中位数
数据结构·算法·leetcode
hetao17338374 小时前
2026-10-08 hetao1733837 的刷题记录
c++·算法
CoderYanger4 小时前
一轮复习——F.动态规划模型总结(入门篇)
java·开发语言·数据结构·算法·leetcode·职场和发展·动态规划
Frank_refuel4 小时前
【C++】智能指针
开发语言·c++
浅念-5 小时前
动态规划专题:斐波那契数列模型 + 网格路径DP(LeetCode例题全解析)
笔记·算法·leetcode·面试·职场和发展·动态规划·推荐算法
一只旭宝5 小时前
数据结构与算法复习手册:从写过,到讲清楚
开发语言·数据结构·c++·算法
十五年专注C++开发5 小时前
std::filesystem::exists 在有的win10系统抛异常原因分析
c++·文件系统·filesystem